@page "/"
@using Microsoft.Extensions.Localization
@inject IStringLocalizer<Index> _localizer
@inject NavigationManager _navigationManager

@inject ISnackbar _snackbar

<MudContainer MaxWidth="MaxWidth.Large">
    @* Hero banner *@
    <MudContainer Class="pa-0 ma-0 my-5">
        <MudPaper Outlined="false" Elevation="0" Class="px-4 my-5">
            <MudGrid>
                <MudItem md="6" Class="pa-4 align-self-center" Style="text-align: center;">
                    <img style="width: 80%;" src="assets/illustrations/undraw_code_review.svg" alt="Overtest"/>
                </MudItem>
                <MudItem md="6" Class="pa-4 align-self-center">
                    <MudText Typo="Typo.h4" Class="ma-0" Style="font-weight: bold; line-height: 1;">@_localizer["Познайомтесь з Overtest"]</MudText>
                    <MudText Typo="Typo.body1" Class="my-3">
                        @_localizer["Вітаємо вас на головній сторінці електронного освітнього ресурсу для викладання курсів і проведення змагань з програмування \"Overtest\"!"]
                        @_localizer["Почніть свій шлях до вивчення алгоритмізації та основ програмування з розв'язування практичних завдань різної складності вже зараз."]
                    </MudText>
                    <MudContainer Class="pa-0 ma-0">
                        <MudButton Variant="Variant.Filled" Size="Size.Large" Color="Color.Primary" StartIcon="@Icons.Filled.Wysiwyg"
                                   OnClick="@(() => _navigationManager.NavigateTo("/tasks/archive/"))">@_localizer["Архів завдань"]</MudButton>
                        &nbsp;
                        <MudButton Variant="Variant.Outlined" Size="Size.Large" Color="Color.Default" StartIcon="@Icons.Filled.Assignment"
                                   OnClick="@(() => _navigationManager.NavigateTo("/tasks/deferred/"))">@_localizer["Відкладені завдання"]</MudButton>
                    </MudContainer>
                </MudItem>
            </MudGrid>
        </MudPaper>
    </MudContainer>
    @* /Hero banner *@
    
    @* Development version alert *@
    @if (_showDevelopmentAlert)
    {
        <MudContainer Class="pa-0 ma-0 my-5">
            <MudAlert Severity="Severity.Info" ContentAlignment="HorizontalAlignment.Center" Class="my-5"
                      ShowCloseIcon="true" CloseIconClicked="@(() => _showDevelopmentAlert = !_showDevelopmentAlert)">
                @_localizer["Ви використовуєте розробницьку версію Overtest. Деякий функціонал може бути нестабільним!"]
            </MudAlert>
        </MudContainer>
    }
    @* /Development version alert *@
    
    @* Base services grid *@
    <MudContainer Class="pa-0 ma-0 my-5">
        <MudGrid Class="my-5">
            <MudItem md="4">
                @PlaceFeature(
                    _localizer["Архів завдань"],
                    _localizer["Набувайте практичних навичок з програмування і написання алгоритмів у вільному режимі роботі - прегляньте Архів завдань прямо зараз!"],
                    _localizer["Перейти"], () => _navigationManager.NavigateTo("/tasks/archive/"))
            </MudItem>

            <MudItem md="4">
                @PlaceFeature(
                    _localizer["Домашні завдання"],
                    _localizer["Виконуйте домашні завдання і лабораторні роботи прямо у браузері, не використовуючи сторонні інструменти, включно з редакторами коду та IDE."],
                    _localizer["Перейти"], ShowServiveUnavailableSnackbarMessage)
            </MudItem>

            <MudItem md="4">
                @PlaceFeature(_localizer["Змагання і турніри"],
                    _localizer["Беріть участь у онлайнових змаганнях і турнірах з програмування, що організовує ваш навчальний заклад - змагайтеся з друзями й одногрупниками."],
                    _localizer["Перейти"], ShowServiveUnavailableSnackbarMessage)
            </MudItem>
        </MudGrid>
    </MudContainer>
    @* /Base services grid *@
</MudContainer>

@code {
    private bool _showDevelopmentAlert;

    protected override void OnInitialized()
    {
        base.OnInitialized();
        _showDevelopmentAlert = Environment.GetEnvironmentVariable("ASPNETCORE_ENVIRONMENT") is "Development";
    }

    private RenderFragment PlaceFeature(string title, string description, string linkTitle, Action linkAction)
    {
        return @<MudCard Outlined="true" Class="ma-0">
                   <MudCardContent>
                       <MudText Typo="Typo.h6">@title</MudText>
                       <MudText Typo="Typo.body2">@description</MudText>
                   </MudCardContent>

                   <MudCardActions>
                       <MudButton Variant="Variant.Text" Color="Color.Primary" EndIcon="@Icons.Filled.ChevronRight" OnClick="linkAction">@linkTitle</MudButton>
                   </MudCardActions>
               </MudCard>;
    }

    private void ShowServiveUnavailableSnackbarMessage()
    {
        _snackbar.Add(_localizer["Запитуваний вами сервіс знаходиться у розробці і стане доступним у наступних версіях Overtest."], Severity.Info);
    }
}